<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   close="titlewindowCloseHandler(event)" creationComplete="creationCompleteHandler(event)" title="Pesquisa de Classificação Fornecedor" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>
	
	
	<fx:Metadata>
		[Event(name="ClassificacaoFornecedorSelecionadoEvent")]
	</fx:Metadata>
	
	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.controls.DateField;
			import mx.validators.Validator;
			
			
			import br.com.desenv.nepalign.vo.Page;
			import br.com.desenv.nepalign.vo.ClassificacaoFornecedor;

			
			[Bindable]
			public var listaClassificacaoFornecedor: ArrayCollection = new ArrayCollection();
			private var pageNumber: int = 1;
			private var totalRecords: int;
			private var pageSize: int = 15;
			private var lastPage: int = 1;
			

			
			private var classificacaoFornecedorComponenteDetalhe: ClassificacaoFornecedorComponenteDetalhe;

			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}

			private function montarObjetoFiltro(): ClassificacaoFornecedor
			{
				var classificacaoFornecedorFiltro: ClassificacaoFornecedor = new ClassificacaoFornecedor();
				
				classificacaoFornecedorFiltro.descricao = ignTextInputDescricaoPesquisa.text == ""?null:"%" + ignTextInputDescricaoPesquisa.text + "%";
				return classificacaoFornecedorFiltro;
			}
			
			private function creationCompleteHandler( event: FlexEvent ): void {
				carregarListaValidacao();
				
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				
				
				var classificacaoFornecedorFiltro: ClassificacaoFornecedor = new ClassificacaoFornecedor();
				remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, classificacaoFornecedorFiltro); 
			}
			
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- RETORNO DA FUNCAO LISTAR  --------------------------------	
			
			private function listarResultHandler( event: ResultEvent ): void {
				var paginaClassificacaoFornecedor: Page = event.result as Page;
				pageNumber = paginaClassificacaoFornecedor.pageNumber;
				totalRecords = paginaClassificacaoFornecedor.totalRecords;
				lastPage = paginaClassificacaoFornecedor.lastPage();
				listaClassificacaoFornecedor = paginaClassificacaoFornecedor.recordList;
				labelPaginaAtual.text = "" + paginaClassificacaoFornecedor.pageNumber;
				labelTotalRegistro.text = "Total de Registros " + paginaClassificacaoFornecedor.totalRecords;
			}

// CARREGANDO COMBOS			

// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				
	
			
			
// -------------FUNCAO DE FILTRAR  -------------------------------------------------------			

			private function buttonFiltrarClickHandler( event: MouseEvent ): void {
				if (validar(event))
				{
					var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
					remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1, montarObjetoFiltro());
				}	 
			}
			
// -------------FUNCOES DE INSERIR E ATUALIZAR  -------------------------------------------------------			

			private function buttonInserir_clickHandler( event: MouseEvent): void 
			{
				var classificacaoFornecedorComponenteCadastro: ClassificacaoFornecedorComponenteCadastro = new ClassificacaoFornecedorComponenteCadastro();
				classificacaoFornecedorComponenteCadastro.classificacaoFornecedor = new ClassificacaoFornecedor(); 
				classificacaoFornecedorComponenteCadastro.addEventListener("ClassificacaoFornecedorIncluidoEvent", atualizarListaClassificacaoFornecedorPorInclusaoResultHandler);
				UPCPopUpManager.instance.addPopUp(classificacaoFornecedorComponenteCadastro, this, true);
				UPCPopUpManager.instance.centerWindow(classificacaoFornecedorComponenteCadastro);
			}
			
			protected function buttonFechar_clickHandler(event:MouseEvent):void
			{
				var classificacaoFornecedorSelecionado: ClassificacaoFornecedor = datagridListaClassificacaoFornecedor.selectedItem as ClassificacaoFornecedor;
				this.dispatchEvent(new ResultEvent("ClassificacaoFornecedorSelecionadoEvent",false, true, classificacaoFornecedorSelecionado, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			protected function datagridListaClassificacaoFornecedor_doubleClickHandler(event:MouseEvent):void
			{
				classificacaoFornecedorComponenteDetalhe = new ClassificacaoFornecedorComponenteDetalhe();
				classificacaoFornecedorComponenteDetalhe.classificacaoFornecedor = datagridListaClassificacaoFornecedor.selectedItem as ClassificacaoFornecedor;
				classificacaoFornecedorComponenteDetalhe.addEventListener("ClassificacaoFornecedorExcluidoEvent", atualizarListaClassificacaoFornecedorPorExclusaoResultHandler);
				classificacaoFornecedorComponenteDetalhe.addEventListener("ClassificacaoFornecedorAtualizadoEvent", atualizarListaClassificacaoFornecedorPorAtualizacaoResultHandler);
				UPCPopUpManager.instance.addPopUp(classificacaoFornecedorComponenteDetalhe, this, true);
				UPCPopUpManager.instance.centerWindow(classificacaoFornecedorComponenteDetalhe);
			}
			
			
			private function atualizarListaClassificacaoFornecedorPorInclusaoResultHandler(e:Event):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro()); 
			}
			
			private function atualizarListaClassificacaoFornecedorPorAtualizacaoResultHandler(e:Event):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
				
			}
			
			
			private function atualizarListaClassificacaoFornecedorPorExclusaoResultHandler(e:Event):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, pageNumber, montarObjetoFiltro()); 
			}
			
			
			
			
		
// -------------FUNCOES DE NAVEGACAO -------------------------------------------------------			
			protected function linkButtonProximaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	

				if (pageNumber < lastPage)
				{
					remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber + 1), montarObjetoFiltro());
				}
				else
				{
					remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage, montarObjetoFiltro());
				}				
			}
			
			protected function linkButtonAnteriorPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				
				if (pageNumber > 1)
				{
					remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, (pageNumber - 1) , montarObjetoFiltro());
				}
				else
				{
					remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro());
				}
			}
			
			protected function linkButtonPrimeiraPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, 1 , montarObjetoFiltro()); 
			}
			
			protected function linkButtonUltimaPagina_clickHandler(event:MouseEvent):void
			{
				var remoteObjectClassificacaoFornecedor: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("classificacaoFornecedorService", listarResultHandler);	
				remoteObjectClassificacaoFornecedor.getOperation("listarPaginadoPorObjetoFiltro").send(pageSize, lastPage , montarObjetoFiltro()); 
			}
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
	</fx:Declarations>
	
	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>


			<mx:GridItem styleName="gridLabel">
				<s:Label text="Classificação:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricaoPesquisa" styleName="labelValidacao" text="{ignTextInputDescricaoPesquisa.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricaoPesquisa" obrigatorio="false" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>



 			<mx:GridItem colSpan="2">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="right">
				<mx:Button id="buttonFiltrar" label="Filtrar" click="buttonFiltrarClickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4">
				<s:Spacer/>	
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				
				
				<mx:LinkButton id="linkButtonPrimeiraPagina" label="&lt;&lt;" click="linkButtonPrimeiraPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonAnteriorPagina" label="&lt;" click="linkButtonAnteriorPagina_clickHandler(event)"/>
				<mx:Label id="labelPaginaAtual" text=""/>
				<mx:LinkButton id="linkButtonProximaPagina" label="&gt;" click="linkButtonProximaPagina_clickHandler(event)"/>
				<mx:LinkButton id="linkButtonUltimaPagina" label="&gt;&gt;" click="linkButtonUltimaPagina_clickHandler(event)"/>				
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<mx:DataGrid id="datagridListaClassificacaoFornecedor"  width="100%" verticalScrollPolicy="on" horizontalScrollPolicy="on" dataProvider="{listaClassificacaoFornecedor}" doubleClick="datagridListaClassificacaoFornecedor_doubleClickHandler(event)" doubleClickEnabled="true">
					<mx:columns>
						<mx:DataGridColumn visible="false" dataField="id"/>
						<mx:DataGridColumn dataField="descricao" headerText="Classificação" resizable="true"/>
					</mx:columns>
				</mx:DataGrid>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			
			<mx:GridItem colSpan="2" horizontalAlign="left">
				<mx:Label id="labelTotalRegistro" text=""/>
			</mx:GridItem>
			<mx:GridItem colSpan="2" horizontalAlign="right">
				<mx:Button id="buttonInserir" label="Novo" click="buttonInserir_clickHandler(event)"/>
				<mx:Button id="buttonFechar" label="Fechar" click="buttonFechar_clickHandler(event)"/>
			</mx:GridItem>	
		</mx:GridRow>
				
	</mx:Grid>
</s:TitleWindow>
